LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.ALL;

library work;
use work.coefficients.all;
USE work.my_package.all; 	--USE work.my_package.all;
--USE work.my_functions.all;	--USE work.my_functions.all;


---------------------------------------------------
-- MY FIR filter
-- Version 2.0
-- 11 coefficients 
-- Author: Vebjrn Bystrm, NTNU 8.may 2008
---------------------------------------------------

-------------- ENTITY -----------------------------
ENTITY my_fir IS
    PORT (
        x: IN std_logic_vector(7 downto 0);
		  clk, rst : IN std_logic;
        y: OUT std_logic_vector(23 downto 0)
        );
END my_fir;
---------------------------------------------------


-------------- ARCHITECTURE -----------------------

ARCHITECTURE rtl of my_fir IS

TYPE registers IS ARRAY (2 downto 0) -- trenger bare 3 registere nr transponert
OF std_logic_vector(23 downto 0);

SIGNAL reg: registers;

type coefreg is array (3 downto 0) of std_logic_vector(23 downto 0);

signal coeff : coefreg;

--------------------PROCESS------------------------	
BEGIN
		
	
		
--	process(clk, rst)

--	BEGIN
--		--- reset registers ---
--		if (rst = '1') then 
--			reg <= (others => (others => '0'));
--		--- update registers ---
--		elsif (clk'EVENT and clk ='1') then
--			for k in 3 downto 1 loop 
--				reg(k) <= reg(k-1);
--			end loop;
--			reg(0) <= x;
--			
--		end if;
--	END PROCESS;
--	
	
	process(clk, rst)
	begin
		if (rst = '1') then 
			reg <= (others => (others => '0'));
		elsif (clk'EVENT and clk ='1') then
			reg(0) <= coeff(0);
			reg(1) <= reg(0) + coeff(1);
			reg(2) <= reg(1) + coeff(2);
			y 		 <= reg(2) + coeff(3);
		end if;

	end process;
	
	
--- oppretter koeffisientert -----
	
	c0:coeff_0 port map(x, coeff(0));
	c1:coeff_1 port map(x, coeff(1));
	c2:coeff_2 port map(x, coeff(2));
	c3:coeff_3 port map(x, coeff(3));
----------------------------------

--- oppretter bussmakroer --------

	--b0:busmacro_xc4v_l2r_async_wide port map(x,reg(0));
	--b1:busmacro_xc4v_l2r_async_wide port map(x,reg(1));
	--b2:busmacro_xc4v_l2r_async_wide port map(x,reg(2));
	--b3:busmacro_xc4v_l2r_async_wide port map(x,reg(3));	


	
END rtl;
--------------------------------------------------
