LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;
USE work.my_package.all;

---------------------------------------------------
-- FIR filter
-- Computation of the coefficients
-- Version 2.0
-- 4 coefficients 
-- Author: Haakon Helsing, NTNU June 2009
---------------------------------------------------


LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;
USE work.my_package.all;

--------------  COEFF_0 ---------------------------
entity coeff_0 is
	port( c : in std_logic_vector(7 downto 0);
			o : out std_logic_vector(23 downto 0));
end entity;

architecture behaviour of coeff_0 is
			
	BEGIN
		process(c)
		
		VARIABLE temp : std_logic_vector (23 DOWNTO 0); 

		VARIABLE shift0: std_logic_vector (23 DOWNTO 0);
		VARIABLE shift1: std_logic_vector (23 DOWNTO 0);
		VARIABLE shift2: std_logic_vector (23 DOWNTO 0);
		
		begin
			temp := c & "0000000000000000";
			shift0 := (temp sra 6); 
			shift1 := (temp sra 9); 
			shift2 := (temp sra 15); 
			
			o <= shift2 - shift0 - shift1;
		end process;
		
	END behaviour; -- coeff0
----------------------------------------------------

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;
USE work.my_package.all;

entity coeff_1 is
	port( c : in std_logic_vector(7 downto 0);
			o : out std_logic_vector(23 downto 0));
end entity;


--------------  COEFF_1 ---------------------------
architecture behaviour of coeff_1 is
			
	BEGIN
		process(c)
		
		VARIABLE temp : std_logic_vector (23 DOWNTO 0); 

		VARIABLE shift0: std_logic_vector (23 DOWNTO 0);
		VARIABLE shift1: std_logic_vector (23 DOWNTO 0);
		VARIABLE shift2: std_logic_vector (23 DOWNTO 0);
		VARIABLE shift3: std_logic_vector (23 DOWNTO 0);
		VARIABLE shift4: std_logic_vector (23 DOWNTO 0);
		VARIABLE shift5: std_logic_vector (23 DOWNTO 0);
		VARIABLE shift6: std_logic_vector (23 DOWNTO 0);
		
		begin
			temp := c & "0000000000000000";
			shift0 := (temp sra 0); 
			shift1 := (temp sra 4); 
			shift2 := (temp sra 7); 
			shift3 := (temp sra 9); 
			shift4 := (temp sra 11); 
			shift5 := (temp sra 13); 
			shift6 := (temp sra 15); 
			
			o <= shift0 - shift1 - shift2 - shift3 + shift4 - shift5 - shift6; 
		end process;
		
	
	END behaviour; --end coeff1
----------------------------------------------------
	
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;
USE work.my_package.all;	
	
	
entity coeff_2 is
	port( c : in std_logic_vector(7 downto 0);
			o : out std_logic_vector(23 downto 0));
end entity;


--------------  COEFF_2 ---------------------------
architecture behaviour of coeff_2 is
			
	BEGIN
		process(c)
		
		VARIABLE temp : std_logic_vector (23 DOWNTO 0); 

		VARIABLE shift0: std_logic_vector (23 DOWNTO 0);
		VARIABLE shift1: std_logic_vector (23 DOWNTO 0);
		VARIABLE shift2: std_logic_vector (23 DOWNTO 0);
		VARIABLE shift3: std_logic_vector (23 DOWNTO 0);

		begin
			temp := c & "0000000000000000";
			shift0 := (temp sra 8); 
			shift1 := (temp sra 10); 
			shift2 := (temp sra 13); 
			shift3 := (temp sra 15); 
			
			o <= shift0 - shift1 + shift2 - shift3; 
		end process;
		
	
	END behaviour; --end coeff2
----------------------------------------------------


	
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;
USE work.my_package.all;	
	
	
entity coeff_3 is
	port( c : in std_logic_vector(7 downto 0);
			o : out std_logic_vector(23 downto 0));
end entity;


--------------  COEFF_3 ---------------------------
architecture behaviour of coeff_3 is
			
	BEGIN
		process(c)
		
		VARIABLE temp : std_logic_vector (23 DOWNTO 0); 
		VARIABLE shift0: std_logic_vector (23 DOWNTO 0);
		VARIABLE shift1: std_logic_vector (23 DOWNTO 0);
		VARIABLE shift2: std_logic_vector (23 DOWNTO 0);
		VARIABLE shift3: std_logic_vector (23 DOWNTO 0);
		VARIABLE shift4: std_logic_vector (23 DOWNTO 0);


		begin
			temp := c & "0000000000000000"; 
			shift0 := (temp sra 1); 
			shift1 := (temp sra 3); 
			shift2 := (temp sra 7); 
			shift3 := (temp sra 12); 
			shift4 := (temp sra 15);  
			
			o <= shift1 + shift2 + shift3 - shift4 - shift0;
			--o <= temp2(23 downto 17);
		 end process;
		
	
	END behaviour; --end coeff3
